/******************************************************************************/
/***                Generated by IBExpert 11.09.2018 9:50:52                ***/
/******************************************************************************/

/******************************************************************************/
/***      Following SET SQL DIALECT is just for the Database Comparer       ***/
/******************************************************************************/
SET SQL DIALECT 3;



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE DP_GRATING (
    POSITION_UUID     DM_UUID /* DM_UUID = CHAR(36) NOT NULL */,
    CO_POSITION_UUID  DM_UUID /* DM_UUID = CHAR(36) NOT NULL */,
    CNT               DM_STATUS /* DM_STATUS = INTEGER */,
    SNAME             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    CO_SNAME          DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    PERC              DM_DOUBLE /* DM_DOUBLE = DOUBLE PRECISION */,
    ACTUAL            DM_STATUS /* DM_STATUS = INTEGER */,
    D$UUID            DM_UUID /* DM_UUID = CHAR(36) NOT NULL */,
    D$SRVUPDDT        DM_DATETIME /* DM_DATETIME = TIMESTAMP */
);




/******************************************************************************/
/***                           Unique constraints                           ***/
/******************************************************************************/

ALTER TABLE DP_GRATING ADD CONSTRAINT UNQ1_DP_GRATING UNIQUE (D$UUID);


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE INDEX IDX_DP_GRATING_1 ON DP_GRATING (POSITION_UUID);


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/



SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: DP_GRATING_AD_DISTR */
CREATE OR ALTER TRIGGER DP_GRATING_AD_DISTR FOR DP_GRATING
ACTIVE AFTER DELETE POSITION 0
AS
begin
  update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_GRATING',old.d$uuid,2,null)
  matching (TABLENAME,UUID);
end
^


/* Trigger: DP_GRATING_BI0 */
CREATE OR ALTER TRIGGER DP_GRATING_BI0 FOR DP_GRATING
INACTIVE BEFORE INSERT POSITION 0
AS
 /*$$IBE$$ declare variable b dm_text; $$IBE$$*/ 
begin /*$$IBE$$ 
  new.perc=0;
  for select l.barcode from dp_gbclinks l where l.position_uuid=new.position_uuid into :b do
    select  new.perc+count(distinct w.doc_id) from DP_WORK w where w.barcode=:b into  new.perc;
  if (new.perc<>0) then
    new.perc=100*new.cnt/new.perc;
 $$IBE$$*/ POST_EVENT '$$IBE$$';
end
^


/* Trigger: DP_GRATING_BI_DISTR */
CREATE OR ALTER TRIGGER DP_GRATING_BI_DISTR FOR DP_GRATING
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if (new.d$uuid is null) then
  begin
    new.d$uuid=UUID_TO_CHAR(GEN_UUID());
    new.d$srvupddt='2000-01-01';
    update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_GRATING',new.d$uuid,0,null) matching (TABLENAME,UUID);
  end
end
^


/* Trigger: DP_GRATING_BU_DISTR */
CREATE OR ALTER TRIGGER DP_GRATING_BU_DISTR FOR DP_GRATING
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  if (new.D$SRVUPDDT=old.D$SRVUPDDT) then
  begin
     update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_GRATING',new.d$uuid,1,null)
     matching (TABLENAME,UUID);
  end

end
^

SET TERM ; ^



/******************************************************************************/
/***                              Descriptions                              ***/
/******************************************************************************/

COMMENT ON TABLE DP_GRATING IS 
'     ,   -.
position_uuid  co_position_uuis -     DP_GBCLINKS';



/******************************************************************************/
/***                               Privileges                               ***/
/******************************************************************************/


