/******************************************************************************/
/***               Generated by IBExpert 11.09.2018 10:24:24                ***/
/******************************************************************************/

/******************************************************************************/
/***      Following SET SQL DIALECT is just for the Database Comparer       ***/
/******************************************************************************/
SET SQL DIALECT 3;



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/


CREATE GENERATOR GEN_DP_LRATING_ID;

CREATE TABLE DP_LRATING (
    ID                DM_ID NOT NULL /* DM_ID = BIGINT */,
    CNT               DM_STATUS /* DM_STATUS = INTEGER */,
    POSITION_UUID     DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    CO_POSITION_UUID  DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    PART_ID           DM_ID_NULL /* DM_ID_NULL = BIGINT */,
    CO_PART_ID        DM_ID_NULL /* DM_ID_NULL = BIGINT */,
    WARE_ID           DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    CO_WARE_ID        DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    BARCODE           DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    CO_BARCODE        DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    NAME_ID           DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    CO_NAME_ID        DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    SNAME             DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    CO_SNAME          DM_TEXT /* DM_TEXT = VARCHAR(250) */,
    GROUP_ID          DM_ID_NULL /* DM_ID_NULL = BIGINT */,
    CO_GROUP_ID       DM_ID_NULL /* DM_ID_NULL = BIGINT */,
    DHASH             DM_ID /* DM_ID = BIGINT */,
    NAME_RULE         DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    CO_NAME_RULE      DM_UUID_NULL /* DM_UUID_NULL = CHAR(36) */,
    D$UUID            DM_UUID /* DM_UUID = CHAR(36) NOT NULL */,
    D$SRVUPDDT        DM_DATETIME /* DM_DATETIME = TIMESTAMP */
);




/******************************************************************************/
/***                           Unique constraints                           ***/
/******************************************************************************/

ALTER TABLE DP_LRATING ADD CONSTRAINT UNQ1_DP_LRATING UNIQUE (D$UUID);


/******************************************************************************/
/***                              Primary keys                              ***/
/******************************************************************************/

ALTER TABLE DP_LRATING ADD CONSTRAINT PK_DP_LRATING_1 PRIMARY KEY (ID);


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE INDEX DP_LRATING_IDX1 ON DP_LRATING (POSITION_UUID);
CREATE INDEX DP_LRATING_IDX2 ON DP_LRATING (PART_ID);
CREATE INDEX DP_LRATING_IDX3 ON DP_LRATING (WARE_ID);
CREATE INDEX DP_LRATING_IDX4 ON DP_LRATING (BARCODE);
CREATE INDEX DP_LRATING_IDX5 ON DP_LRATING (NAME_ID);
CREATE INDEX DP_LRATING_IDX6 ON DP_LRATING (GROUP_ID);
CREATE INDEX DP_LRATING_IDX7 ON DP_LRATING (DHASH);


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/



SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: DP_LRATING_AD_DISTR */
CREATE OR ALTER TRIGGER DP_LRATING_AD_DISTR FOR DP_LRATING
ACTIVE AFTER DELETE POSITION 0
AS
begin
  update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_LRATING',old.d$uuid,2,null)
  matching (TABLENAME,UUID);
end
^


/* Trigger: DP_LRATING_BI */
CREATE OR ALTER TRIGGER DP_LRATING_BI FOR DP_LRATING
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_dp_lrating_id,1);
  if (new.group_id is not null) then
    select caption from groups where id=new.group_id into new.sname;
  if (new.co_group_id is not null) then
    select caption from groups where id=new.co_group_id into new.co_sname;

  if (new.position_uuid is not null) then
    select sname from dp_gbclinks where position_uuid=new.position_uuid into new.sname;
  if (new.co_position_uuid is not null) then
    select sname from dp_gbclinks where position_uuid=new.co_position_uuid into new.co_sname;

  if (new.part_id is not null) then
    select (select svalue from vals v where id=(select name_id from wares w where w.id=p.ware_id)) from parts p where p.id=new.part_id into new.sname;
  if (new.co_part_id is not null) then
    select (select svalue from vals v where id=(select name_id from wares w where w.id=p.ware_id)) from parts p where p.id=new.co_part_id into new.co_sname;

  if (new.ware_id is not null) then
    select (select svalue from vals v where id=w.name_id) from wares w where w.id=new.ware_id into new.sname;
  if (new.co_ware_id is not null) then
    select (select svalue from vals v where id=w.name_id) from wares w where w.id=new.co_ware_id into new.co_sname;

  if (new.barcode is not null) then
    select first 1 (select svalue from vals v where id=w.name_id) from wares w where w.barcode=new.barcode into new.sname;
  if (new.co_barcode is not null) then
    select first 1 (select svalue from vals v where id=w.name_id) from wares w where w.barcode=new.co_barcode into new.co_sname;

  if (new.name_id is not null) then
    select svalue from vals v where id=new.name_id into new.sname;
  if (new.co_name_id is not null) then
    select svalue from vals v where id=new.co_name_id into new.co_sname;

  if (new.name_rule is not null) then
    select list(NAME_KEY||coalesce(trim(a1)||' ',' ')||coalesce(trim(a2)||' ',' ')||coalesce(trim(a3)||' ',' ')||coalesce(trim(a4)||' ',' ')) from dp_namelinks where position_uuid=new.name_rule into new.sname;
  if (new.co_name_rule is not null) then
    select list(NAME_KEY||coalesce(trim(a1)||' ',' ')||coalesce(trim(a2)||' ',' ')||coalesce(trim(a3)||' ',' ')||coalesce(trim(a4)||' ',' ')) from dp_namelinks where position_uuid=new.co_name_rule into new.co_sname;


--  new.dhash=hash(coalesce(new.POSITION_UUID,'')||','||coalesce(new.PART_ID,'')||','||coalesce(new.WARE_ID,'')||','||coalesce(new.BARCODE,'')||','||coalesce(new.NAME_ID,'')||','||coalesce(new.GROUP_ID,''));
  new.dhash=hash(coalesce(new.POSITION_UUID,'')||','||coalesce(new.PART_ID,'')||','||coalesce(new.WARE_ID,'')||','||coalesce(new.BARCODE,'')||','||coalesce(new.NAME_ID,'')||','||coalesce(new.GROUP_ID,'')||','||coalesce(new.name_rule,''));

end
^


/* Trigger: DP_LRATING_BI_DISTR */
CREATE OR ALTER TRIGGER DP_LRATING_BI_DISTR FOR DP_LRATING
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if (new.d$uuid is null) then
  begin
    new.d$uuid=UUID_TO_CHAR(GEN_UUID());
    new.d$srvupddt='2000-01-01';
    update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_LRATING',new.d$uuid,0,null) matching (TABLENAME,UUID);
  end
end
^


/* Trigger: DP_LRATING_BU0 */
CREATE OR ALTER TRIGGER DP_LRATING_BU0 FOR DP_LRATING
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
--  new.dhash=hash(coalesce(new.POSITION_UUID,'')||','||coalesce(new.PART_ID,'')||','||coalesce(new.WARE_ID,'')||','||coalesce(new.BARCODE,'')||','||coalesce(new.NAME_ID,'')||','||coalesce(new.GROUP_ID,''));
  new.dhash=hash(coalesce(new.POSITION_UUID,'')||','||coalesce(new.PART_ID,'')||','||coalesce(new.WARE_ID,'')||','||coalesce(new.BARCODE,'')||','||coalesce(new.NAME_ID,'')||','||coalesce(new.GROUP_ID,'')||','||coalesce(new.name_rule,''));
end
^


/* Trigger: DP_LRATING_BU_DISTR */
CREATE OR ALTER TRIGGER DP_LRATING_BU_DISTR FOR DP_LRATING
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  if (new.D$SRVUPDDT=old.D$SRVUPDDT) then
  begin
     update or insert into g$distribute (TABLENAME,UUID,SOPER,FROM_PROFILE_ID) values ('DP_LRATING',new.d$uuid,1,null)
     matching (TABLENAME,UUID);
  end

end
^

SET TERM ; ^



/******************************************************************************/
/***                               Privileges                               ***/
/******************************************************************************/


INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (281, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', NULL, NULL, NULL, 3537644755891489280, '2454B4BB-EDAA-45B4-BF2A-A795B64097E8', NULL, 'F7A077A2-1B2C-4142-9389-19666C8BE1DF', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (283, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', '    ', NULL, NULL, 3537644755891489280, '2454B4BB-EDAA-45B4-BF2A-A795B64097E8', '6A92F1EB-8A5D-4898-9C3B-70511B96DBF5', '55A7D3CB-EC34-4454-91EB-D86E3BF36418', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (276, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', NULL, NULL, NULL, 614772359761573760, '40ECB931-DF5F-43A1-965E-44A8977DC52F', NULL, '2969ACD6-D400-4DEA-B4A6-C34A7BFBE5EC', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (277, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', '    ', NULL, NULL, 614772359761573760, '40ECB931-DF5F-43A1-965E-44A8977DC52F', '02D76E9C-9CCF-4A9E-B15B-8C2FDDC7F78E', 'EB47E0FC-B9C3-486E-A574-4694609F1416', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (278, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', '    ', NULL, NULL, 614772359761573760, '40ECB931-DF5F-43A1-965E-44A8977DC52F', '887F354A-B09A-485E-8A1D-A3BA684702C5', '0581C171-F31C-437A-93C3-87E3FF95C524', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (270, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, ' 10 ', NULL, NULL, NULL, 704475737816701568, 'CE4EA2FF-C35C-4ACD-B6FC-7538D0A68328', NULL, '03617EA9-28D0-45B7-86F3-583B4C347568', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (271, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, ' 10 ', ' ', NULL, NULL, 704475737816701568, 'CE4EA2FF-C35C-4ACD-B6FC-7538D0A68328', '877F8450-F60C-4B60-A767-F29BA143FB6D', '52ED9BC5-E3DB-404B-9128-D48540ED0FA4', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (279, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', NULL, NULL, NULL, 597943930568039040, '47EDE5E7-99A6-40F6-8803-4126969C24CC', NULL, '2947D851-5EF7-4250-8671-444A935E9A44', '2000-01-01 00:00:00');
INSERT INTO DP_LRATING (ID, CNT, POSITION_UUID, CO_POSITION_UUID, PART_ID, CO_PART_ID, WARE_ID, CO_WARE_ID, BARCODE, CO_BARCODE, NAME_ID, CO_NAME_ID, SNAME, CO_SNAME, GROUP_ID, CO_GROUP_ID, DHASH, NAME_RULE, CO_NAME_RULE, D$UUID, D$SRVUPDDT)
                VALUES (280, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '    ', ' 10   ', NULL, NULL, 597943930568039040, '47EDE5E7-99A6-40F6-8803-4126969C24CC', 'CE4EA2FF-C35C-4ACD-B6FC-7538D0A68328', '671CDC86-A118-490B-A456-9F0AB73EA45E', '2000-01-01 00:00:00');

COMMIT WORK;
